package gui;

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */


 import javax.swing.JFrame;
 import javax.swing.SwingUtilities;
 import clientP2P.*;
 import tools.LogLevel;
 import tools.Logger;
 import serverP2P.ServerManagementUDP;
 import serverP2P.ServerManagementTCP;

/**
* @author	Louis Royer
* @author	Flavien Haas
* @author	JS Auge
* @version 1.0
 */
public class DownloadSelectionGen extends javax.swing.JPanel {

	private javax.swing.JButton jButton1;
	private javax.swing.JButton jButton2;
	private javax.swing.JLabel jLabel1;
	private javax.swing.JList<String> jList1;
	private javax.swing.JScrollPane jScrollPane1;
	private static final long serialVersionUID = 13L;
	private String[] listFilesToDownload;
	private ClientManagement clientManagement;
	private Logger logger;
	private ServerManagementTCP smtcp;
	private ServerManagementUDP smudp;


		/**
		 * @param listFilesToDownload list of files to display
		 * @param clientManagement clientManagement
		 * @param logger logger
		 * Creates new form ArgumentsGen
		 */
		public DownloadSelectionGen(String[] listFilesToDownload, ClientManagement clientManagement,  Logger logger, ServerManagementTCP smtcp, ServerManagementUDP smudp) {
				this.listFilesToDownload = listFilesToDownload;
				this.clientManagement = clientManagement;
				this.logger = logger;
				this.smtcp = smtcp;
				this.smudp = smudp;
				initComponents();
		}

		/**
		 * This method is called from within the constructor to initialize the form.
		 */
		@SuppressWarnings("unchecked")
		// <editor-fold defaultstate="collapsed" desc="Generated Code">
		private void initComponents() {

				jLabel1 = new javax.swing.JLabel();
				jButton1 = new javax.swing.JButton();
				jScrollPane1 = new javax.swing.JScrollPane();
				jList1 = new javax.swing.JList<>();
				jButton2 = new javax.swing.JButton();

				jLabel1.setText("Select a file to download:");

				jButton1.setText("Download");
				jButton1.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent evt) {
								jButton1ActionPerformed(evt);
						}
				});

				jList1.setModel(new javax.swing.AbstractListModel<String>() {
						String[] strings = listFilesToDownload;
						public int getSize() { return strings.length; }
						public String getElementAt(int i) { return strings[i]; }
				});
				jScrollPane1.setViewportView(jList1);

				jList1.setSelectedIndex(0);
				jButton2.setText("Back");
							 jButton2.addActionListener(new java.awt.event.ActionListener() {
									 public void actionPerformed(java.awt.event.ActionEvent evt) {
											 jButton2ActionPerformed(evt);
									 }
							 });


							javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
							this.setLayout(layout);
							layout.setHorizontalGroup(
									layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
									.addGroup(layout.createSequentialGroup()
											.addContainerGap()
											.addComponent(jLabel1)
											.addGap(0, 0, Short.MAX_VALUE))
									.addGroup(layout.createSequentialGroup()
											.addGap(97, 97, 97)
											.addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 300, javax.swing.GroupLayout.PREFERRED_SIZE)
											.addContainerGap(104, Short.MAX_VALUE))
									.addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
											.addGap(25, 25, 25)
											.addComponent(jButton2)
											.addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
											.addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 121, javax.swing.GroupLayout.PREFERRED_SIZE)
											.addGap(23, 23, 23))
							);
							layout.setVerticalGroup(
									layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
									.addGroup(layout.createSequentialGroup()
											.addContainerGap()
											.addComponent(jLabel1)
											.addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
											.addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 134, javax.swing.GroupLayout.PREFERRED_SIZE)
											.addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
											.addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
													.addComponent(jButton1)
													.addComponent(jButton2))
											.addContainerGap(24, Short.MAX_VALUE))
							);
					}// </editor-fold>


					/** Actions to initiate when button "Download" is pressed */
					private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {
							String fileSelected = jList1.getSelectedValue();
							System.out.println("File to download: " + fileSelected);
							DownloadFileGUI dl = new DownloadFileGUI(fileSelected, clientManagement, logger, smtcp, smudp);
							dl.download();
					}

					/** Actions to initiate when button "Back" is initiate */
					private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {
							ArgumentsGen a = new ArgumentsGen();
							JFrame topFrame = (JFrame) SwingUtilities.getWindowAncestor(this);
							topFrame.add(a);
							this.setVisible(false);
					}

}
